package org.jvnet.hifaces.components.templatedpanel.impl;

import java.io.IOException;
import java.net.URL;

import javax.faces.context.FacesContext;

public class ClassPathTemplateNameResolver implements TemplateNameResolver {

	private final URL baseURL;

	public ClassPathTemplateNameResolver() {
		this(null);
	}

	public ClassPathTemplateNameResolver(final URL baseURL) {
		this.baseURL = baseURL;
	}

	protected URL getURL(FacesContext contex, String templateName) {

		final URL url = getClass().getClassLoader().getResource(templateName);
		return url;
	}

	public TemplateResource resolve(FacesContext contex, String templateName)
			throws IOException {

		final URL url = getURL(contex, templateName);

		return new URLTemplateResource(url);
	}

}
