package org.jvnet.hifaces.event;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class ChangeListenerList extends AbstractWeakListenerList {

  public void addChangeListener(ChangeListener listener) {
    add(listener);
  }

  public void removeChangeListener(ChangeListener listener) {
    remove(listener);
  }

  public void clearChangeListeners() {
    clear();
  }
  
  public void fireChangeEvent(ChangeEvent event)
  {
    fire(event);
  }
  
  public void fireChangeEvent(Object source)
  {
    fire(new ChangeEvent(source));
  }
  

  protected void fire(Object listenerDraft, Object eventDraft) {
    final ChangeListener listener = (ChangeListener) listenerDraft;
    final ChangeEvent event = (ChangeEvent) eventDraft;
    listener.stateChanged(event);
  }
}
