package org.jvnet.hifaces.event;

import java.util.Enumeration;

import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;
import javax.servlet.http.HttpSession;

public class SessionDispatchingPhaseListener implements PhaseListener {

  public void afterPhase(PhaseEvent event) {
    final int phaseId = event.getPhaseId().getOrdinal();
    final HttpSession session = (HttpSession) event
        .getFacesContext()
        .getExternalContext()
        .getSession(false);
    if (session != null) {
      for (Enumeration attributeNames = session.getAttributeNames(); attributeNames
          .hasMoreElements();) {
        final String attributeName = (String) attributeNames.nextElement();
        final Object value = session.getAttribute(attributeName);
        if (value instanceof PhaseListener) {
          final PhaseListener phaseListener = (PhaseListener) value;

          int targetPhaseId = phaseListener.getPhaseId().getOrdinal();
          if (phaseId == targetPhaseId || PhaseId.ANY_PHASE.getOrdinal() == targetPhaseId) {
            phaseListener.afterPhase(event);
          }
        }
      }
    }
  }

  public void beforePhase(PhaseEvent event) {
    final int phaseId = event.getPhaseId().getOrdinal();
    final HttpSession session = (HttpSession) event
        .getFacesContext()
        .getExternalContext()
        .getSession(false);
    if (session != null) {
      for (Enumeration attributeNames = session.getAttributeNames(); attributeNames
          .hasMoreElements();) {
        final String attributeName = (String) attributeNames.nextElement();
        final Object value = session.getAttribute(attributeName);
        if (value instanceof PhaseListener) {
          final PhaseListener phaseListener = (PhaseListener) value;

          int targetPhaseId = phaseListener.getPhaseId().getOrdinal();
          if (phaseId == targetPhaseId || PhaseId.ANY_PHASE.getOrdinal() == targetPhaseId) {
            phaseListener.beforePhase(event);
          }
        }
      }
    }
  }

  public PhaseId getPhaseId() {
    return PhaseId.ANY_PHASE;
  }
}
