package org.jvnet.hifaces.model.paging;

/**
 * Delivers data in pages. Used by data paging model.
 * 
 * @see PagingDataModel
 * @param <T>
 *            Type of the entry.
 */
public interface DataPageable<T> {

	/**
	 * Returns data page for the given starting index and page size. Please note
	 * that this method must not throw any exceptions. All exceptions from the
	 * data access layer must be handled before returning passing the page.
	 * 
	 * 
	 * @param start
	 *            starting index.
	 * @param pageSize
	 *            page size.
	 * @return Data page.
	 */
	public DataPage<T> getPage(int start, int pageSize);

}
