package org.jvnet.hifaces.myfaces.custom.tree2;

import org.apache.myfaces.custom.tree2.TreeState;

public class SmartTreeState implements TreeState {

	private static final long serialVersionUID = 1L;

	boolean _transient = false;

	private String _selected;

	private final SmartTreeNode root;

	public SmartTreeState(final SmartTreeNode root) {
		this.root = root;
	}

	public void expandPath(String[] nodePath) {
		for (int i = 0; i < nodePath.length; i++) {
			final String nodeId = nodePath[i];
			final SmartTreeNode node = root.getNodeById(nodeId);
			if (node != null) {
				node.expand();
			}
		}
	}

	public void collapsePath(String[] nodePath) {
		for (int i = 0; i < nodePath.length; i++) {
			final String nodeId = nodePath[i];
			final SmartTreeNode node = root.getNodeById(nodeId);
			if (node != null) {
				node.collapse();
			}
		}
	}

	public void toggleExpanded(String nodeId) {
		final SmartTreeNode node = root.getNodeById(nodeId);
		if (node == null) {
			// do nothing
		} else {
			node.toggle();
		}
	}

	public boolean isTransient() {
		return _transient;
	}

	public void setTransient(boolean trans) {
		_transient = trans;
	}

	public boolean isNodeExpanded(String nodeId) {
		final SmartTreeNode node = root.getNodeById(nodeId);
		if (node == null) {
			return false;
		} else {
			return node.isExpanded();
		}
	}

	public void setSelected(String nodeId) {
		_selected = nodeId;
	}

	public String getSelected() {
		return _selected;
	}

	public boolean isSelected(String nodeId) {
		return nodeId.equals(_selected);
	}

}
