package org.jvnet.hifaces.springframework.util;

import java.util.Enumeration;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.faces.context.FacesContext;

import org.springframework.context.MessageSource;
import org.springframework.context.NoSuchMessageException;
import org.springframework.web.jsf.FacesContextUtils;

public class FacesContextResourceBundle extends ResourceBundle {

	private static final Object[] NONE = new Object[0];

	private static final long serialVersionUID = 1L;

	private transient MessageSource messageSource;

	protected MessageSource getMessageSource(final FacesContext facesContext) {
		if (messageSource == null) {
			messageSource = FacesContextUtils
					.getWebApplicationContext(facesContext);
		}
		return messageSource;
	}

	protected Object handleGetObject(String key) {

		String message = null;

		final FacesContext facesContext = FacesContext.getCurrentInstance();
		if (facesContext != null) {
			final MessageSource messageSource = getMessageSource(facesContext);
			final Locale locale = facesContext.getViewRoot().getLocale();
			try {
				message = messageSource.getMessage(key, NONE, locale);
			} catch (NoSuchMessageException nsmex) {
				// Suppress exception
			}
		}
		if (message == null) {
			message = "???" + key + "???";
		}
		return message;
	}

	public Enumeration getKeys() {
		return null;
	}
}
