package org.jvnet.hifaces.util;

import java.io.Serializable;

public class DualString implements Serializable {

  private static final long serialVersionUID = 1L;

  private final String hi;

  private final String lo;

  public DualString(String hi, String lo) {
    super();
    this.hi = hi;
    this.lo = lo;
  }

  public String getHi() {
    return hi;
  }

  public String getLo() {
    return lo;
  }

  public int hashCode() {
    return (hi == null ? 0 : hi.hashCode()) ^ (lo == null ? 0 : lo.hashCode());
  }

  public boolean equals(Object obj) {
    if (!(obj instanceof DualString)) {
      return false;

    }
    else {
      final DualString otherKey = (DualString) obj;
      final String hi = getHi();
      final String lo = getLo();
      final String otherHi = otherKey.getHi();
      final String otherLo = otherKey.getLo();
      return (hi == null ? otherHi == null : hi.equals(otherHi))
          && (lo == null ? otherLo == null : lo.equals(otherLo));
    }
  }
}
